package com.hero.objects.talents;

import org.jdom.Element;

import com.hero.HeroDesigner;
import com.hero.objects.GenericObject;

/**
 * Copyright (c) 2000 - 2005, CompNet Design, Inc. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, is prohibited unless the following conditions are met: 1.
 * Express written consent of CompNet Design, Inc. is obtained by the developer.
 * 2. Redistributions must retain this copyright notice. THIS SOFTWARE IS
 * PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * @author CompNet Design, Inc.
 * @version $Revision$
 */

public class LightningReflexesAll extends Talent {

	public static String xmlID = "LIGHTNING_REFLEXES_ALL";

	public LightningReflexesAll(Element root) {
		super(root, LightningReflexesAll.xmlID);
		setLevels(getLevels());
	}

	@Override
	public void setLevels(int val) {
		super.setLevels(val);
		if (getDisplay().indexOf("All Actions") > 0) {
			String part1 = getDisplay().substring(0,
					getDisplay().indexOf("All Actions"));
			String part2 = getDisplay().substring(
					getDisplay().indexOf("All Actions"), getDisplay().length());
			setAlias(part1 + "+" + getLevels() + " DEX to act first with "
					+ part2);
		}
	}

	@Override
	public String getColumn2Output() {
		if (HeroDesigner.getActiveTemplate().is6E()) {

			String ret = getAlias();
			if ((getName() != null) && (getName().trim().length() > 0)) {
				ret = "<i>" + getName() + ":</i>  " + ret;
			}
			if (getSelectedOption() != null) {
				ret += " (";
				ret += "+"+getLevels()+" DEX to act first with ";
				ret += getSelectedOption().getAlias();

				String adderString = getAdderString();
				if (adderString.trim().length() > 0) {
					ret += "; " + adderString;
				}
				ret += ")";
			} else {
				String adderString = getAdderString();
				if (adderString.trim().length() > 0) {
					ret += " (" + adderString + ")";
				}
			}
			ret += getModifierString();
			if ((getEndUsage() > 0)
					&& (GenericObject.findObjectByID(HeroDesigner
							.getActiveHero().getPowers(), "ENDURANCERESERVE") != null)
					&& (GenericObject.findObjectByID(getAssignedModifiers(),
							"ENDRESERVEOREND") == null)
					&& !HeroDesigner.getInstance().getPrefs().useWG()) {
				if (getUseENDReserve()) {
					ret += " (uses END Reserve)";
				} else {
					ret += " (uses Personal END)";
				}
			}
			return ret;
		} else {
			return super.getColumn2Output();
		}
	}
}